BpGraphWriter< BGR > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions | Related Functions
BpGraphWriter< BGR > Class Template Reference
LEMON Graph Format

## Detailed Description

### template<typename BGR>
class lemon::BpGraphWriter< BGR >

This utility writes an LGF file.

It can be used almost the same way as `GraphWriter`, but it reads the red and blue nodes from separate sections, and these sections can contain different set of maps.

The red and blue node maps are written to the corresponding sections. The node maps are written to both of these sections with the same map name.

`#include <lemon/lgf_writer.h>`

## Public Member Functions
| BpGraphWriter (const BGR &graph, std::ostream &os=std::cout)
| Constructor. More...
| BpGraphWriter (const BGR &graph, const std::string &fn)
| Constructor. More...
| BpGraphWriter (const BGR &graph, const char *fn)
| Constructor. More...
| ~BpGraphWriter ()
| Destructor.
Writing Rules
template<typename Map >
BpGraphWriter & | nodeMap (const std::string &caption, const Map &map)
| Node map writing rule. More...
template<typename Map , typename Converter >
BpGraphWriter & | nodeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Node map writing rule. More...
template<typename Map >
BpGraphWriter & | redNodeMap (const std::string &caption, const Map &map)
| Red node map writing rule. More...
template<typename Map , typename Converter >
BpGraphWriter & | redNodeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Red node map writing rule. More...
template<typename Map >
BpGraphWriter & | blueNodeMap (const std::string &caption, const Map &map)
| Blue node map writing rule. More...
template<typename Map , typename Converter >
BpGraphWriter & | blueNodeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Blue node map writing rule. More...
template<typename Map >
BpGraphWriter & | edgeMap (const std::string &caption, const Map &map)
| Edge map writing rule. More...
template<typename Map , typename Converter >
BpGraphWriter & | edgeMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Edge map writing rule. More...
template<typename Map >
BpGraphWriter & | arcMap (const std::string &caption, const Map &map)
| Arc map writing rule. More...
template<typename Map , typename Converter >
BpGraphWriter & | arcMap (const std::string &caption, const Map &map, const Converter &converter=Converter())
| Arc map writing rule. More...
template<typename Value >
BpGraphWriter & | attribute (const std::string &caption, const Value &value)
| Attribute writing rule. More...
template<typename Value , typename Converter >
BpGraphWriter & | attribute (const std::string &caption, const Value &value, const Converter &converter=Converter())
| Attribute writing rule. More...
BpGraphWriter & | node (const std::string &caption, const Node &node)
| Node writing rule. More...
BpGraphWriter & | redNode (const std::string &caption, const RedNode &node)
| Red node writing rule. More...
BpGraphWriter & | blueNode (const std::string &caption, const BlueNode &node)
| Blue node writing rule. More...
BpGraphWriter & | edge (const std::string &caption, const Edge &edge)
| Edge writing rule. More...
BpGraphWriter & | arc (const std::string &caption, const Arc &arc)
| Arc writing rule. More...
Section Captions
BpGraphWriter & | nodes (const std::string &caption)
| Add an additional caption to the `@red_nodes` and `@blue_nodes` section. More...
BpGraphWriter & | edges (const std::string &caption)
| Add an additional caption to the `@edges` section. More...
BpGraphWriter & | attributes (const std::string &caption)
| Add an additional caption to the `@attributes` section. More...
Skipping Section
BpGraphWriter & | skipNodes ()
| Skip writing the node set. More...
BpGraphWriter & | skipEdges ()
| Skip writing edge set. More...
Execution of the Writer
void | run ()
| Start the batch processing. More...
std::ostream & | ostream ()
| Give back the stream of the writer. More...

## Related Functions
(Note that these are not member functions.)
template<typename TBGR >
BpGraphWriter< TBGR > | bpGraphWriter (const TBGR &graph, std::ostream &os)
| Return a BpGraphWriter class. More...
template<typename TBGR >
BpGraphWriter< TBGR > | bpGraphWriter (const TBGR &graph, const std::string &fn)
| Return a BpGraphWriter class. More...
template<typename TBGR >
BpGraphWriter< TBGR > | bpGraphWriter (const TBGR &graph, const char *fn)
| Return a BpGraphWriter class. More...

## Constructor & Destructor Documentation

BpGraphWriter | ( | const BGR & | graph,
|  | std::ostream & | os = `std::cout`
| ) |  |
| inline

Construct a bipartite graph writer, which writes to the given output stream.

BpGraphWriter | ( | const BGR & | graph,
|  | const std::string & | fn
| ) |  |
| inline

Construct a bipartite graph writer, which writes to the given output file.

BpGraphWriter | ( | const BGR & | graph,
|  | const char * | fn
| ) |  |
| inline

Construct a bipartite graph writer, which writes to the given output file.

## Member Function Documentation

BpGraphWriter& nodeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add a node map writing rule to the writer.

BpGraphWriter& nodeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add a node map writing rule with specialized converter to the writer.

BpGraphWriter& redNodeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add a red node map writing rule to the writer.

BpGraphWriter& redNodeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add a red node map writing rule with specialized converter to the writer.

BpGraphWriter& blueNodeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add a blue node map writing rule to the writer.

BpGraphWriter& blueNodeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add a blue node map writing rule with specialized converter to the writer.

BpGraphWriter& edgeMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add an edge map writing rule to the writer.

BpGraphWriter& edgeMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an edge map writing rule with specialized converter to the writer.

BpGraphWriter& arcMap | ( | const std::string & | caption,
|  | const Map & | map
| ) |  |
| inline

Add an arc map writing rule to the writer.

BpGraphWriter& arcMap | ( | const std::string & | caption,
|  | const Map & | map,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an arc map writing rule with specialized converter to the writer.

BpGraphWriter& attribute | ( | const std::string & | caption,
|  | const Value & | value
| ) |  |
| inline

Add an attribute writing rule to the writer.

BpGraphWriter& attribute | ( | const std::string & | caption,
|  | const Value & | value,
|  | const Converter & | converter = `Converter()`
| ) |  |
| inline

Add an attribute writing rule with specialized converter to the writer.

BpGraphWriter& node | ( | const std::string & | caption,
|  | const Node & | node
| ) |  |
| inline

Add a node writing rule to the writer.

BpGraphWriter& redNode | ( | const std::string & | caption,
|  | const RedNode & | node
| ) |  |
| inline

Add a red node writing rule to the writer.

BpGraphWriter& blueNode | ( | const std::string & | caption,
|  | const BlueNode & | node
| ) |  |
| inline

Add a blue node writing rule to the writer.

BpGraphWriter& edge | ( | const std::string & | caption,
|  | const Edge & | edge
| ) |  |
| inline

Add an edge writing rule to writer.

BpGraphWriter& arc | ( | const std::string & | caption,
|  | const Arc & | arc
| ) |  |
| inline

Add an arc writing rule to writer.

BpGraphWriter& nodes | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@red_nodes` and `@blue_nodes` section.

BpGraphWriter& edges | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@edges` section.

BpGraphWriter& attributes | ( | const std::string & | caption | ) |
| inline

Add an additional caption to the `@attributes` section.

BpGraphWriter& skipNodes | ( |  | ) |
| inline

The `@red_nodes` and `@blue_nodes` section will not be written to the stream.

BpGraphWriter& skipEdges | ( |  | ) |
| inline

The `@edges` section will not be written to the stream.

void run | ( |  | ) |
| inline

This function starts the batch processing.

std::ostream& ostream | ( |  | ) |
| inline

Give back the stream of the writer

## Friends And Related Function Documentation

BpGraphWriter< TBGR > bpGraphWriter | ( | const TBGR & | graph,
|  | const std::string & | fn
| ) |  |
| related

This function just returns a BpGraphWriter class.

See Also
  graphWriter(const TBGR& graph, std::ostream& os)

BpGraphWriter< TBGR > bpGraphWriter | ( | const TBGR & | graph,
|  | const char * | fn
| ) |  |
| related

This function just returns a BpGraphWriter class.

See Also
  graphWriter(const TBGR& graph, std::ostream& os)